## simutrans 123.0.1

=== CMakeLists.txt ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

cmake_minimum_required(VERSION 3.16)

# Disable in-source builds
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "Building Simutrans in-source is not supported. "
		"Please delete ${CMAKE_SOURCE_DIR}/CMakeCache.txt and configure in a different "
		"(preferrably empty) directory.")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

set(CMAKE_WARN_DEPRECATED ON)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")

include(SimutransVcpkgTriplet)

project(simutrans LANGUAGES C CXX)

# Force C++11 everywhere
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS OFF)

include(TestBigEndian)
TEST_BIG_ENDIAN(SIMUTRANS_BIG_ENDIAN)

if (MINGW)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ON)
	set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++")
endif ()

if (APPLE)
	link_directories(/usr/local/lib)
	set(CMAKE_EXE_LINKER_FLAGS "-framework Cocoa")
endif ()


#
# Dependencies
#
find_package(CCache)
find_package(ZLIB REQUIRED)
find_package(BZip2 REQUIRED)
find_package(PNG REQUIRED)
find_package(MiniUPNP)
if (MSVC)
	find_package(ZSTD)
	find_package(SDL2)
	find_package(Freetype)
	find_package(FluidSynth)
else ()
	find_package(PkgConfig MODULE REQUIRED)
	pkg_check_modules(ZSTD IMPORTED_TARGET libzstd)
	pkg_check_modules(SDL2 IMPORTED_TARGET sdl2)
	pkg_check_modules(Freetype IMPORTED_TARGET freetype2)
	pkg_check_modules(FluidSynth IMPORTED_TARGET fluidsynth>=2.1.0)
endif ()

set(CMAKE_THREAD_PREFER_PTHREAD ON)
find_package(Threads)

#
# Configuration options
#
include(SimutransBackend) # Select backend (SDL2 / GDI)
include(SimutransCompileOptions)


# CMake does not fill in CMAKE_BUILD_TYPE automatically.
if (NOT MSVC)
	if (CMAKE_BUILD_TYPE STREQUAL "")
		set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type. Valid values are Debug Release MinSizeRel RelWithDebInfo" FORCE)
	endif ()
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)
endif (NOT MSVC)


#
# sources
#
add_executable(simutrans MACOSX_BUNDLE)
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	set_target_properties(simutrans PROPERTIES WIN32_EXECUTABLE 1)
endif ()

include(SimutransSourceList)


#
# output directory
#
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/simutrans)
set_target_properties( simutrans PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/simutrans/$<0:> )


#
# Generate revision on compile time (so only if needed)
#
string(FIND ${CMAKE_GENERATOR} "Visual Studio" VS )
if (${VS} EQUAL 0)
	# using a script for MSVC project files
	file(WRITE ${CMAKE_SOURCE_DIR}/revision.h "#define REVISION \n")
	add_custom_command(TARGET simutrans PRE_BUILD WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND cscript.exe /Nologo revision.jse COMMENT "Find SVN revision")
else ()
	# using custom target svnhear that is always built to update the revision.h file using cmake script
	add_custom_target(svnheader ALL DEPENDS svn_header)
	add_custom_command(OUTPUT svn_header COMMAND ${CMAKE_COMMAND} -DSOURCE_DIR=${CMAKE_SOURCE_DIR} -P ${CMAKE_MODULE_PATH}/SimutransRevision.cmake)
	set_source_files_properties(${CMAKE_SOURCE_DIR}/revision.h PROPERTIES GENERATED TRUE HEADER_FILE_ONLY TRUE)
	add_dependencies(simutrans svnheader)
endif ()

#
# Libraries
#

target_link_libraries(simutrans PRIVATE PNG::PNG)

if (WIN32)
	target_sources(simutrans PRIVATE simres.rc)
	target_sources(simutrans PRIVATE sys/clipboard_w32.cc)
	target_link_libraries(simutrans PRIVATE ws2_32 winmm)

	# Backup sound and music routines if the selected backend does not provide any routines
	set(BACKUP_SOUND sound/win32_sound_xa.cc)
	set(BACKUP_MUSIC music/w32_midi.cc)
else ()
	if (SIMUTRANS_BACKEND STREQUAL "sdl2")
		target_sources(simutrans PRIVATE sys/clipboard_s2.cc)
	else ()
		target_sources(simutrans PRIVATE sys/clipboard_internal.cc)
	endif ()
	if (APPLE)
		target_sources(simutrans PRIVATE OSX/translocation.m)
		#Darwin kernel version is used to identify macOS version (16->10.12/Sierra)
		if (CMAKE_HOST_SYSTEM_VERSION VERSION_GREATER_EQUAL 16) #AVF
			set(BACKUP_SOUND sound/AVF_core-audio_sound.mm)
			#AVF MIDI currently crash Simutrans
			#set(BACKUP_MUSIC music/AVF_core-audio_midi.mm)
			set(BACKUP_MUSIC music/no_midi.cc)
		else () #QTKit
			set(BACKUP_SOUND sound/core-audio_sound.mm)
			set(BACKUP_MUSIC music/core-audio_midi.mm)
		endif ()
	else ()
		set(BACKUP_SOUND sound/no_sound.cc)
		set(BACKUP_MUSIC music/no_midi.cc)
	endif ()
endif ()

if (SIMUTRANS_MULTI_THREAD)
	target_compile_definitions(simutrans PRIVATE MULTI_THREAD=1)
	target_link_libraries(simutrans PRIVATE Threads::Threads)
endif (SIMUTRANS_MULTI_THREAD)

if (SIMUTRANS_BACKEND STREQUAL "sdl2")
	target_sources(simutrans PRIVATE display/simgraph16.cc sys/simsys_s2.cc sound/sdl2_sound.cc)
	target_include_directories(simutrans PRIVATE ${SDL2_INCLUDE_DIRS})
	if (MINGW)
		target_link_libraries(simutrans PRIVATE ${SDL2_STATIC_LIBRARIES})
	elseif (APPLE)
		target_link_libraries(simutrans PRIVATE ${SDL2_LIBRARIES})
	elseif (MSVC)
		target_link_libraries(simutrans PRIVATE SDL2::SDL2)
	else ()
		target_link_libraries(simutrans PRIVATE PkgConfig::SDL2)
	endif ()
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=16)

elseif (SIMUTRANS_BACKEND STREQUAL "gdi")
	target_sources(simutrans PRIVATE display/simgraph16.cc sys/simsys_w.cc ${BACKUP_SOUND} )
	target_link_libraries(simutrans PRIVATE imm32 xaudio2_8)
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=16)

else ()
	if (NOT SIMUTRANS_BACKEND STREQUAL "none")
		message(WARNING "Unknown backend '${SIMUTRANS_BACKEND}', falling back to headless compilation")
	endif ()

	target_sources(simutrans PRIVATE display/simgraph0.cc sys/simsys_posix.cc sound/no_sound.cc music/no_midi.cc)
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=0)
endif ()


#
# Link dependencies
#
target_link_libraries(simutrans PRIVATE ZLIB::ZLIB)
target_link_libraries(simutrans PRIVATE BZip2::BZip2)

if (SIMUTRANS_USE_FREETYPE)
	target_include_directories(simutrans PRIVATE ${Freetype_INCLUDE_DIRS})
	if (MINGW)
		target_link_libraries(simutrans PRIVATE ${Freetype_STATIC_LIBRARIES})
	elseif (APPLE)
		target_link_libraries(simutrans PRIVATE ${Freetype_LIBRARIES})
	elseif (MSVC)
		target_link_libraries(simutrans PRIVATE Freetype::Freetype)
	else ()
		target_link_libraries(simutrans PRIVATE PkgConfig::Freetype)
	endif ()
	target_compile_definitions(simutrans PRIVATE USE_FREETYPE=1)
endif (SIMUTRANS_USE_FREETYPE)

if (SIMUTRANS_USE_UPNP)
	target_compile_definitions(simutrans PRIVATE USE_UPNP=1)
	target_link_libraries(simutrans PRIVATE MiniUPNP::MiniUPNP)
endif (SIMUTRANS_USE_UPNP)

if (SIMUTRANS_USE_ZSTD)
	target_sources(simutrans PRIVATE io/rdwr/zstd_file_rdwr_stream.cc)
	target_include_directories(simutrans PRIVATE ${ZSTD_INCLUDE_DIRS})
	target_compile_definitions(simutrans PRIVATE USE_ZSTD=1)
	if (MSVC)
		target_link_libraries(simutrans PRIVATE zstd::libzstd_static)
	elseif (MINGW)
		# only 64 bit cmake, 32 bit is broken
		target_link_libraries(simutrans PRIVATE -lzstd)
	else()
		target_link_libraries(simutrans PRIVATE PkgConfig::ZSTD)
	endif ()
endif (SIMUTRANS_USE_ZSTD)

# only consider FluidSynth for SDL2 and GDI backends
if ((SIMUTRANS_BACKEND STREQUAL "sdl2") OR (SIMUTRANS_BACKEND STREQUAL "gdi"))
	if (SIMUTRANS_USE_FLUIDSYNTH_MIDI)
		target_sources(simutrans PRIVATE music/fluidsynth.cc gui/loadsoundfont_frame.cc)
		target_compile_definitions(simutrans PRIVATE USE_FLUIDSYNTH_MIDI=1)
		if (MINGW)
			# since fluidsynth 2.2.2 fluidsynth.pc include static libraries, but some are still missing
			target_link_libraries(simutrans PRIVATE ${FluidSynth_STATIC_LIBRARIES} -liconv -lgomp)
		elseif (MSVC)
			target_link_libraries(simutrans PRIVATE ${FluidSynth_LIBRARIES})
		else ()
			target_link_libraries(simutrans PRIVATE PkgConfig::FluidSynth)
		endif (MINGW)
	else ()
		target_sources( simutrans PRIVATE ${BACKUP_MUSIC} )
	endif (SIMUTRANS_USE_FLUIDSYNTH_MIDI)
endif ((SIMUTRANS_BACKEND STREQUAL "sdl2") OR (SIMUTRANS_BACKEND STREQUAL "gdi"))


#
# compile options
#
if (MSVC)
	target_link_options(simutrans PRIVATE /INCREMENTAL:NO /NODEFAULTLIB:LIBCMTD /MANIFEST:NO /LARGEADDRESSAWARE)
endif ()

if (SIMUTRANS_BIG_ENDIAN)
	target_compile_definitions(simutrans PRIVATE SIM_BIG_ENDIAN=1)
endif ()

if (SIMUTRANS_VALGRIND_SUPPORT)
	add_definitions(-DUSE_VALGRIND_MEMCHECK=1)
endif ()

if (SIMUTRANS_ENABLE_PROFILING)
	add_definitions(-DPROFILE=1)
endif ()

target_compile_options(simutrans PRIVATE ${SIMUTRANS_COMMON_COMPILE_OPTIONS})

target_compile_definitions(simutrans PRIVATE $<IF:$<CONFIG:Debug>,DEBUG=1,>)
target_compile_definitions(simutrans PRIVATE $<IF:$<CONFIG:Release>,NDEBUG=1,>)

target_compile_definitions(simutrans PRIVATE MSG_LEVEL=${SIMUTRANS_MSG_LEVEL})

if (SIMUTRANS_AUTOJOIN_PUBLIC)
	target_compile_definitions(simutrans PRIVATE AUTOJOIN_PUBLIC=1)
endif ()

if (SIMUTRANS_ENABLE_WATERWAY_SIGNS)
	target_compile_definitions(simutrans PRIVATE ENABLE_WATERWAY_SIGNS=1)
endif ()

if (SIMUTRANS_USE_SYSLOG)
	target_compile_definitions(simutrans PRIVATE SYSLOG=1)
endif ()

if (SIMUTRANS_DEBUG_FLUSH_BUFFER)
	target_compile_definitions(simutrans PRIVATE DEBUG_FLUSH_BUFFER=1)
endif ()

if (SIMUTRANS_USE_IP4_ONLY)
	target_compile_definitions(simutrans PRIVATE USE_IP4_ONLY=1)
endif ()

if (SIMUTRANS_STEAM_BUILT)
	target_compile_definitions(simutrans PRIVATE STEAM_BUILT=1)
endif ()

if (APPLE)
	target_compile_definitions(simutrans PRIVATE ALT_SDL_DIR=1)
endif (APPLE)

#
# Package
#
if (APPLE)
	include(MacBundle)
endif ()


#
# Tests
#
add_custom_target(test
	$<TARGET_FILE:simutrans>
		-set_workdir ${CMAKE_CURRENT_SOURCE_DIR}/simutrans
		-objects pak
		-scenario automated-tests
		-debug 2
		-lang en
		-fps 100
	DEPENDS simutrans
)


#
# Installation
#
install(TARGETS simutrans RUNTIME DESTINATION "${CMAKE_BINARY_DIR}/simutrans/" BUNDLE DESTINATION "${CMAKE_BINARY_DIR}/simutrans/")

install(DIRECTORY "${CMAKE_SOURCE_DIR}/simutrans" DESTINATION "${CMAKE_BINARY_DIR}")

# download language files
if (MSVC)
	# MSVC has no variable on the install target path at execution time, which is why we expand the directories at creation time!
	install(CODE "execute_process(COMMAND powershell -ExecutionPolicy Bypass -File ${CMAKE_SOURCE_DIR}/get_lang_files.ps1 WORKING_DIRECTORY ${simutrans_BINARY_DIR})")
else ()
	install(CODE "execute_process(COMMAND sh ../get_lang_files.sh WORKING_DIRECTORY \${CMAKE_BINARY_DIR})")
endif ()

# pak installer
if (NOT WIN32)
	install(FILES get_pak.sh DESTINATION "${CMAKE_BINARY_DIR}/simutrans/"
		PERMISSIONS
			OWNER_READ OWNER_WRITE OWNER_EXECUTE
			GROUP_READ GROUP_EXECUTE
			WORLD_READ WORLD_EXECUTE
	)
else ()
	# NSIS must be installed manually in the path with the right addons
	if(MINGW)
		install(CODE "execute_process(COMMAND makensis onlineupgrade.nsi WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/nsis)")
	else ()
		install(CODE "execute_process(COMMAND cmd /k \"$ENV{ProgramFiles\(x86\)}/NSIS/makensis.exe\" onlineupgrade.nsi WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/nsis)")
	endif ()
	install(FILES "${CMAKE_SOURCE_DIR}/nsis/download-paksets.exe" DESTINATION "${CMAKE_BINARY_DIR}/simutrans")
endif ()

# install pak if needed
if (SIMUTRANS_INSTALL_PAK64)
	if (MSVC)
		install(CODE
		"if(NOT EXISTS ${simutrans_BINARY_DIR}/simutrans/pak)
		execute_process(COMMAND powershell -Command \"Remove-Item \'${simutrans_BINARY_DIR}/simutrans/pak\' -Recurse\" WORKING_DIRECTORY ${simutrans_BINARY_DIR})
		file(STRINGS ${CMAKE_SOURCE_DIR}/paksetinfo.h URLpak64 REGEX \"/pak64/\")
		string( REGEX REPLACE \"^.[\\t ]*\\\"\" \"\" URLpak64 \${URLpak64})
		string( REGEX REPLACE \"\\\", .*\$\" \"\" URLpak64 \${URLpak64})
		message(\"install pak to \" ${simutrans_BINARY_DIR})
		execute_process(COMMAND powershell -ExecutionPolicy Bypass -File ${CMAKE_SOURCE_DIR}/get_pak.ps1 \${URLpak64} WORKING_DIRECTORY ${simutrans_BINARY_DIR}/simutrans)
		endif ()
		")
	else ()
		# install pak64 with the bundle
		install(CODE

=== Makefile ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

# Define variables here to force them as simple flavor. -> Faster parallel builds.
FLAGS :=
CFLAGS ?=
LDFLAGS ?=
LIBS :=
SOURCES :=
STATIC := 0


CFG ?= default
-include config.$(CFG)


HOSTCC  ?=$(CC)
HOSTCXX ?=$(CXX)

SDL_CONFIG       ?= sdl-config
SDL2_CONFIG      ?= pkg-config sdl2
#SDL2_CONFIG     ?= sdl2-config
FREETYPE_CONFIG  ?= pkg-config freetype2
#FREETYPE_CONFIG ?= freetype-config

BACKENDS  := gdi sdl sdl2 mixer_sdl mixer_sdl2 posix
OSTYPES   := amiga beos freebsd haiku linux mac mingw openbsd


ifeq ($(findstring $(BACKEND), $(BACKENDS)),)
  $(error Unkown BACKEND "$(BACKEND)", must be one of "$(BACKENDS)")
endif

ifeq ($(findstring $(OSTYPE), $(OSTYPES)),)
  $(error Unkown OSTYPE "$(OSTYPE)", must be one of "$(OSTYPES)")
endif

ifeq ($(BACKEND),posix)
  COLOUR_DEPTH := 0
else
  COLOUR_DEPTH := 16
endif

ifeq ($(OSTYPE),amiga)
  STD_LIBS ?= -lunix -lSDL_mixer -lsmpeg -lvorbisfile -lvorbis -logg
  CFLAGS   += -mcrt=newlib -DSIM_BIG_ENDIAN -gstabs+
  LDFLAGS  += -Bstatic -non_shared
else ifeq ($(OSTYPE),beos)
  # BeOS (obsolete)
  LIBS += -lnet
else ifeq ($(OSTYPE),freebsd)
  CFLAGS  += -I/usr/local/include
else ifeq ($(OSTYPE),haiku)
  # Haiku (needs to activate the GCC 4x)
  LIBS += -lnetwork -lbe
else ifeq ($(OSTYPE),mingw)
  CFLAGS    += -DPNG_STATIC -DZLIB_STATIC
  ifeq ($(shell expr $(STATIC) \>= 1), 1)
    CFLAGS  += -static
    LDFLAGS += -static-libgcc -static-libstdc++ -static
  endif
  ifeq ($(MINGW_PACKAGE_PREFIX),mingw-w64-i686)
    LDFLAGS   += -Wl,--large-address-aware
  endif
  LDFLAGS   += -pthread
  CFLAGS    += -Wno-deprecated-copy -DNOMINMAX -DWIN32_LEAN_AND_MEAN -DWINVER=0x0501 -D_WIN32_IE=0x0500
  LIBS      += -lmingw32 -lgdi32 -lwinmm -lws2_32 -limm32

  # Disable the console on Windows unless WIN32_CONSOLE is set or graphics are disabled
  ifdef WIN32_CONSOLE
    ifeq ($(shell expr $(WIN32_CONSOLE) \>= 1), 1)
      LDFLAGS += -mconsole
    endif
  else ifeq ($(BACKEND),posix)
    LDFLAGS += -mconsole
  else
    LDFLAGS += -mwindows
  endif
else ifeq ($(OSTYPE),linux)
  LD_FLAGS += "-Wl,-Bstatic"
else ifeq ($(OSTYPE),mac)
  SOURCES += OSX/translocation.m
  LDFLAGS += -framework Cocoa
endif

ifeq ($(BACKEND),sdl2)
  SOURCES += sys/clipboard_s2.cc
else ifeq ($(OSTYPE),mingw)
  SOURCES += sys/clipboard_w32.cc
else
  SOURCES += sys/clipboard_internal.cc
endif

LIBS += -lbz2 -lz -lpng

ifdef OPTIMISE
  ifeq ($(shell expr $(OPTIMISE) \>= 1), 1)
    CFLAGS += -O3
    ifeq ($(findstring amiga, $(OSTYPE)),)
      ifneq ($(findstring clang, $(CXX)),)
        CFLAGS += -minline-all-stringops
      endif
    endif
  endif
else
  CFLAGS += -O1
endif

ifneq ($(LTO),)
  CFLAGS += -flto
  LDFLAGS += -flto
endif

ifdef DEBUG
  MSG_LEVEL ?= 3
  PROFILE ?= 0

  ifeq ($(shell expr $(DEBUG) \>= 1), 1)
    CFLAGS   += -g -DDEBUG
  endif

  ifeq ($(shell expr $(DEBUG) \>= 2), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline
    endif
  endif

  ifeq ($(shell expr $(DEBUG) \>= 3), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -O0
    endif
  endif
else
  CFLAGS += -DNDEBUG
endif

ifdef MSG_LEVEL
  CFLAGS += -DMSG_LEVEL=$(MSG_LEVEL)
endif

ifdef USE_FREETYPE
  ifeq ($(shell expr $(USE_FREETYPE) \>= 1), 1)
    CFLAGS   += -DUSE_FREETYPE
    ifneq ($(FREETYPE_CONFIG),)
      CFLAGS += $(shell $(FREETYPE_CONFIG) --cflags)
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        # since static is not supported by slightly old freetype versions
        FTF := $(shell $(FREETYPE_CONFIG) --libs --static)
        ifneq ($(FTF),)
          LDFLAGS += $(FTF)
        else
          LDFLAGS += $(shell $(FREETYPE_CONFIG) --libs)
        endif
      else
        LDFLAGS   += $(shell $(FREETYPE_CONFIG) --libs)
      endif
    else
      LDFLAGS += -lfreetype
      ifeq ($(OSTYPE),mingw)
        LDFLAGS += -lpng -lharfbuzz
      endif
    endif

    ifeq ($(OSTYPE),mingw)
      LDFLAGS += -lfreetype
    endif
  endif
endif

ifdef USE_UPNP
  ifeq ($(shell expr $(USE_UPNP) \>= 1), 1)
    CFLAGS      += -DUSE_UPNP
    LDFLAGS     += -lminiupnpc
    ifeq ($(OSTYPE),mingw)
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bdynamic
      endif
      LDFLAGS   += -liphlpapi
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bstatic
      endif
    endif
  endif
endif

ifdef USE_ZSTD
  ifeq ($(shell expr $(USE_ZSTD) \>= 1), 1)
    CFLAGS  += -DUSE_ZSTD
    LDFLAGS += -lzstd
    SOURCES += io/rdwr/zstd_file_rdwr_stream.cc
  endif
endif

ifdef USE_FLUIDSYNTH_MIDI
  ifeq ($(shell expr $(USE_FLUIDSYNTH_MIDI) \>= 1), 1)
    CFLAGS  += -DUSE_FLUIDSYNTH_MIDI
    SOURCES += music/fluidsynth.cc
    SOURCES += gui/loadsoundfont_frame.cc
    LDFLAGS += -lfluidsynth
    ifeq ($(OSTYPE),mingw)
      # fluidsynth.pc doesn't properly list dependant libraries, unable to use pkg-config. Manually listed below. Only valid for fluidsynth built with options: "-DBUILD_SHARED_LIBS=0 -Denable-aufile=0 -Denable-dbus=0 -Denable-ipv6=0 -Denable-jack=0 -Denable-ladspa=0 -Denable-midishare=0 -Denable-opensles=0 -Denable-oboe=0 -Denable-oss=0 -Denable-readline=0 -Denable-winmidi=0 -Denable-waveout=0 -Denable-libsndfile=0 -Denable-network=0 -Denable-pulseaudio=0 Denable-dsound=1 -Denable-sdl2=0"
      LDFLAGS += -lglib-2.0 -lintl -liconv -ldsound -lole32
    endif
  endif
else
  USE_FLUIDSYNTH_MIDI := 0
endif

ifdef PROFILE
  ifeq ($(shell expr $(PROFILE) \>= 1), 1)
    CFLAGS   += -pg -DPROFILE
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline

      ifeq ($(findstring clang, $(CXX)),)
        CFLAGS += -fno-schedule-insns
      endif
    endif
    LDFLAGS  += -pg
  endif
endif

ifdef MULTI_THREAD
  ifeq ($(shell expr $(MULTI_THREAD) \>= 1), 1)
    CFLAGS += -DMULTI_THREAD
    ifneq ($(OSTYPE),haiku)
      # mingw has already added pthread statically
      ifneq ($(OSTYPE),mingw)
        LDFLAGS += -lpthread
      endif
    endif
  endif
endif

ifdef WITH_REVISION
  ifeq ($(shell expr $(WITH_REVISION) \>= 1), 1)
    ifeq ($(shell expr $(WITH_REVISION) \>= 2), 1)
      REV := $(WITH_REVISION)
    else
      REV := $(shell ./get_revision.sh)
      $(info Revision is $(REV))
    endif
  endif
endif

ifneq ($(REV),)
  CFLAGS  += -DREVISION=$(REV)
  DUMMY := $(shell rm -f revision.h)
else
  ifeq ("$(wildcard revision.h)","")
    DUMMY := $(shell echo '\#define REVISION' > revision.h)
  endif
endif

GIT_HASH := $(shell git rev-parse --short=7 HEAD 2>/dev/null 1>/dev/null; echo $$?)
ifneq ($(GIT_HASH),)
  GIT_HASH := $(shell git rev-parse --short=7 HEAD)
  $(info Git hash is 0x$(GIT_HASH))
  CFLAGS  += -DGIT_HASH=0x$(GIT_HASH)
endif


CFLAGS   += -Wall -Wextra -Wcast-qual -Wpointer-arith -Wcast-align $(FLAGS)
CCFLAGS  += -ansi -Wstrict-prototypes -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64


# sources (in alphabetic order)
SOURCES += bauer/brueckenbauer.cc
SOURCES += bauer/fabrikbauer.cc
SOURCES += bauer/goods_manager.cc
SOURCES += bauer/hausbauer.cc
SOURCES += bauer/tunnelbauer.cc
SOURCES += bauer/tree_builder.cc
SOURCES += bauer/vehikelbauer.cc
SOURCES += bauer/wegbauer.cc
SOURCES += boden/boden.cc
SOURCES += boden/brueckenboden.cc
SOURCES += boden/fundament.cc
SOURCES += boden/grund.cc
SOURCES += boden/monorailboden.cc
SOURCES += boden/tunnelboden.cc
SOURCES += boden/wasser.cc
SOURCES += boden/wege/kanal.cc
SOURCES += boden/wege/maglev.cc
SOURCES += boden/wege/monorail.cc
SOURCES += boden/wege/narrowgauge.cc
SOURCES += boden/wege/runway.cc
SOURCES += boden/wege/schiene.cc
SOURCES += boden/wege/strasse.cc
SOURCES += boden/wege/weg.cc
SOURCES += dataobj/crossing_logic.cc
SOURCES += dataobj/environment.cc
SOURCES += dataobj/freelist.cc
SOURCES += dataobj/gameinfo.cc
SOURCES += dataobj/height_map_loader.cc
SOURCES += dataobj/koord.cc
SOURCES += dataobj/koord3d.cc
SOURCES += dataobj/loadsave.cc
SOURCES += dataobj/marker.cc
SOURCES += dataobj/objlist.cc
SOURCES += dataobj/powernet.cc
SOURCES += dataobj/records.cc
SOURCES += dataobj/rect.cc
SOURCES += dataobj/ribi.cc
SOURCES += dataobj/route.cc
SOURCES += dataobj/scenario.cc
SOURCES += dataobj/schedule.cc
SOURCES += dataobj/settings.cc
SOURCES += dataobj/tabfile.cc
SOURCES += dataobj/translator.cc
SOURCES += descriptor/bridge_desc.cc
SOURCES += descriptor/building_desc.cc
SOURCES += descriptor/factory_desc.cc
SOURCES += descriptor/goods_desc.cc
SOURCES += descriptor/ground_desc.cc
SOURCES += descriptor/image.cc
SOURCES += descriptor/obj_base_desc.cc
SOURCES += descriptor/reader/bridge_reader.cc
SOURCES += descriptor/reader/building_reader.cc
SOURCES += descriptor/reader/citycar_reader.cc
SOURCES += descriptor/reader/crossing_reader.cc
SOURCES += descriptor/reader/factory_reader.cc
SOURCES += descriptor/reader/good_reader.cc
SOURCES += descriptor/reader/ground_reader.cc
SOURCES += descriptor/reader/groundobj_reader.cc
SOURCES += descriptor/reader/image_reader.cc
SOURCES += descriptor/reader/imagelist2d_reader.cc
SOURCES += descriptor/reader/imagelist_reader.cc
SOURCES += descriptor/reader/obj_reader.cc
SOURCES += descriptor/reader/pedestrian_reader.cc
SOURCES += descriptor/reader/roadsign_reader.cc
SOURCES += descriptor/reader/root_reader.cc
SOURCES += descriptor/reader/sim_reader.cc
SOURCES += descriptor/reader/skin_reader.cc
SOURCES += descriptor/reader/sound_reader.cc
SOURCES += descriptor/reader/text_reader.cc
SOURCES += descriptor/reader/tree_reader.cc
SOURCES += descriptor/reader/tunnel_reader.cc
SOURCES += descriptor/reader/vehicle_reader.cc
SOURCES += descriptor/reader/way_obj_reader.cc
SOURCES += descriptor/reader/way_reader.cc
SOURCES += descriptor/reader/xref_reader.cc
SOURCES += descriptor/sound_desc.cc
SOURCES += descriptor/tunnel_desc.cc
SOURCES += descriptor/vehicle_desc.cc
SOURCES += descriptor/way_desc.cc
SOURCES += display/font.cc
SOURCES += display/simgraph$(COLOUR_DEPTH).cc
SOURCES += display/simview.cc
SOURCES += display/viewport.cc
SOURCES += finder/placefinder.cc
SOURCES += freight_list_sorter.cc
SOURCES += gui/ai_option_t.cc
SOURCES += gui/ai_selector.cc
SOURCES += gui/banner.cc
SOURCES += gui/base_info.cc
SOURCES += gui/baum_edit.cc
SOURCES += gui/city_info.cc
SOURCES += gui/citybuilding_edit.cc
SOURCES += gui/citylist_frame_t.cc
SOURCES += gui/citylist_stats_t.cc
SOURCES += gui/climates.cc
SOURCES += gui/components/gui_aligned_container.cc
SOURCES += gui/components/gui_building.cc
SOURCES += gui/components/gui_button.cc
SOURCES += gui/components/gui_button_to_chart.cc
SOURCES += gui/components/gui_chart.cc
SOURCES += gui/components/gui_colorbox.cc
SOURCES += gui/components/gui_combobox.cc
SOURCES += gui/components/gui_container.cc
SOURCES += gui/components/gui_convoiinfo.cc
SOURCES += gui/components/gui_divider.cc
SOURCES += gui/components/gui_fixedwidth_textarea.cc
SOURCES += gui/components/gui_flowtext.cc
SOURCES += gui/components/gui_image.cc
SOURCES += gui/components/gui_image_list.cc
SOURCES += gui/components/gui_component.cc
SOURCES += gui/components/gui_label.cc
SOURCES += gui/components/gui_map_preview.cc
SOURCES += gui/components/gui_numberinput.cc
SOURCES += gui/components/gui_obj_view_t.cc
SOURCES += gui/components/gui_schedule.cc
SOURCES += gui/components/gui_scrollbar.cc
SOURCES += gui/components/gui_scrolled_list.cc
SOURCES += gui/components/gui_scrollpane.cc
SOURCES += gui/components/gui_speedbar.cc
SOURCES += gui/components/gui_tab_panel.cc
SOURCES += gui/components/gui_textarea.cc
SOURCES += gui/components/gui_textinput.cc
SOURCES += gui/components/gui_timeinput.cc
SOURCES += gui/components/gui_waytype_tab_panel.cc
SOURCES += gui/components/gui_world_view_t.cc
SOURCES += gui/convoi_detail_t.cc
SOURCES += gui/convoi_filter_frame.cc
SOURCES += gui/convoi_frame.cc
SOURCES += gui/convoi_info_t.cc
SOURCES += gui/convoy_item.cc
SOURCES += gui/curiosity_edit.cc
SOURCES += gui/curiositylist_frame_t.cc
SOURCES += gui/curiositylist_stats_t.cc
SOURCES += gui/depot_frame.cc
SOURCES += gui/depotlist_frame.cc
SOURCES += gui/display_settings.cc

=== debian/changelog ===
simutrans (123.0.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:00:52 +1100

simutrans (123.0.1-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:14:27 +0000

simutrans (123.0.1-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Markus Koschany <apo@debian.org>  Fri, 16 Jun 2023 01:03:47 +0200

simutrans (123.0.1-2) experimental; urgency=medium

  [ Jörg Frings-Fürst ]
  * Build verbosely by default (Closes: #1032414).
    Thanks to Helmut Grohne <helmut@subdivi.de>

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 11 Mar 2023 17:53:36 +0100

simutrans (123.0.1-1) unstable; urgency=medium

  [ Jörg Frings-Fürst ]
  * New upstream release (Closes: #1020687):
    - New debian/patches/0010-build.patch.
    - New debian/patches/0100-workingdir.patch.
    - Refresh patches.
    - Remove not longer used patsches:
      + debian/patches/0100-path_for_game-data.patch
      + debian/patches/0505-link-less-libraries.diff
      + debian/patches/0510-missing_uncommon_mk.patch
      + debian/patches/sha1.patch
    - Update translations.
    - Convert translations to utf-8.
  * debian/control:
    - Add new Build-Depends.
    - Move Depends version of simutrans-pak64 to 121.0.
  * Declare compliance with Debian Policy 4.6.2.0 (No changes needed).
  * debian/copyright:
    - Add year 2023 to myself.
  * debian/rules:
    - Fix FTCBFS: Use the host architecture pkg-config (Closes: #993124).
      Thanks to Helmut Grohne <helmut@subdivi.de>.

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 18 Feb 2023 17:30:51 +0100

=== debian/control ===
Source: simutrans
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <Pkg-games-devel@alioth-lists.debian.net>
Uploaders:
 Clint Adams <clint@debian.org>,
 Jörg Frings-Fürst <debian@jff.email>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libbz2-dev,
 libfluidsynth-dev,
 libfreetype-dev,
 libminiupnpc-dev,
 libpng-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libzstd-dev,
 quilt,
 zlib1g-dev
Standards-Version: 4.6.2.0
Rules-Requires-Root: no
Homepage: http://www.simutrans.com/
Vcs-Git: https://salsa.debian.org/games-team/simutrans.git
Vcs-Browser: https://salsa.debian.org/games-team/simutrans

Package: simutrans
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 simutrans-pak64 (>= 121.0),
 simutrans-data (= ${source:Version})
Suggests: freepats
Description: transportation simulator
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.

Package: simutrans-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: transportation simulator (base data)
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the base data.

Package: simutrans-makeobj
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: data file compiler for Simutrans
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the makeobj program needed to integrate new objects
 in Simutrans.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules file for simutrans

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export VERBOSE  = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/buildtools.mk

export CFLAGS   = $(shell dpkg-buildflags --get CFLAGS)
export CCFLAGS  = $(CFLAGS)
export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
export CXXFLAGS += -D_FORTIFY_SOURCE=2 -std=gnu++11
export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS  = $(shell dpkg-buildflags --get LDFLAGS)

export DEB_BUILD_OPTIONS += nocheck

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- SDL2_CONFIG="$(PKG_CONFIG) sdl2" VERBOSE=$(if $(filter terse,$(DEB_BUILD_OPTIONS)),,1)
	dh_auto_build --sourcedirectory=makeobj -- PNG_CONFIG="$(PKG_CONFIG) libpng" VERBOSE=$(if $(filter terse,$(DEB_BUILD_OPTIONS)),,1)

override_dh_auto_clean:
	dh_quilt_patch
	dh_auto_clean
	$(MAKE) -C makeobj clean
	$(RM) -r skin
	$(RM) -r build

override_dh_install-arch:
	dh_install
	install -m 755 sim $(CURDIR)/debian/simutrans/usr/games/simutrans

override_dh_install-indep:
	find simutrans/text -name "*.txt"  -exec iconv -f iso-8859-1 -t utf-8 {} -o {} \;
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs simutrans/history.txt

update-translations:
	dh_testdir
	wget --post-data "version=0&choice=all&submit=Export!" --delete-after "http://simutrans-germany.com/translator/script/main.php?page=wrap"
	wget -N http://simutrans-germany.com/translator/data/tab/language_pack-Base+texts.zip
	unzip -o -d debian/translations language_pack-Base+texts.zip "*.tab"
	$(RM) language_pack-Base+texts.zip
